    require("libraries/LoveFrames/init")
    require("gui")

-- Some global stuff that the mapss use.
global = {}
global.limitDrawing = false        -- If true then the drawing range maps is shown
global.benchmark = false        -- If true the map is drawn 20 times instead of 1
global.useBatch = false            -- If true then the layers are rendered with sprite batches
global.tx = 0                    -- X translation of the screen
global.ty = 0                    -- Y translation of the screen
global.scale = 1                -- Scale of the screen
global.fps = fps

-- Load the mapss
local maps = {require("inn")}

local num = 1                    -- The map we're currently on
local fps = 0                    -- Frames Per Second
local fpsCount = 0                -- FPS count of the current second
local fpsTime = 0                -- Keeps track of the elapsed time

-- Reset the current maps
if maps[num].reset then maps[num].reset() end



function love.load()


end


-- Scroll in and out
function love.mousepressed( x, y, mb )

    loveframes.mousepressed(x, y, mb)

    if mb == "wu" then
        global.scale = global.scale + 0.1
    end

    if mb == "wd" then
        global.scale = global.scale - 0.1
    end
    

end

function love.mousereleased(x, y, button)

    -- your code

    loveframes.mousereleased(x, y, button)

end

function love.update(dt)

    loveframes.update(dt)

    -- Move the camera
    if love.keyboard.isDown("up") then global.ty = global.ty + 250*dt end
    if love.keyboard.isDown("down") then global.ty = global.ty - 250*dt end
    if love.keyboard.isDown("left") then global.tx = global.tx + 250*dt end
    if love.keyboard.isDown("right") then global.tx = global.tx - 250*dt end
    
    -- Count the frames per second
    fpsCount = fpsCount+1
    fpsTime = fpsTime + dt
    if fpsTime >= 1 then
        fps = fpsCount
        fpsTime = 0
        fpsCount = 0
    end
    
    -- Call update in our maps if it is defined
    if maps[num].update then maps[num].update(dt) end
end


function love.keypressed(k, unicode)

        loveframes.keypressed(k, unicode)

    -- quit
    if k == 'escape' then
        (love.event.push or love.event.quit)('q')
    end
    
    -- previous map
    if k == 'z' then
        num =  num <= 1 and #maps or num - 1
        if maps[num].reset then maps[num].reset() end
    end
    
    -- next map
    if k == 'x' then
        num = num >= #maps and 1 or num + 1
        if maps[num].reset then maps[num].reset() end
    end
    
    -- limit drawing
    if k == 'c' then
        if global.limitDrawing then global.limitDrawing = false else global.limitDrawing = true end
    end
    
    -- benchmark
    if k == 'v' then
        if global.benchmark then global.benchmark = false else global.benchmark = true end
    end
    
    -- use sprite batches
    if k == 'b' then
        if global.useBatch then global.useBatch = false else global.useBatch = true end
    end
    
    
    
    -- Call keypressed in our maps if it is defined
    if maps[num].keypressed then maps[num].keypressed(k) end
end


function love.keyreleased(key)

    -- your code

    loveframes.keyreleased(key)

end


function love.draw()

love.graphics.setColor(255,255,255,255)
    
    -- Draw our maps
    maps[num].draw()
    

    loveframes.draw()
    
 end