tween = require("libraries/tween")

npc = {}
npc.image = love.graphics.newImage("images/maincharacter-1.png")
npc.width = npc.image:getWidth()
npc.height = npc.image:getHeight()
npc.speed = 0.3
npc.moving = false
npc.facing = "down"
npc.tileX = 8
npc.tileY = 8
npc.x = 128
npc.y = 128
npc.map = nil
npc.quads = {
		down = love.graphics.newQuad( 0, 0, 32, 32, npc.width, npc.height )
}

--Draws the npc
function npc.draw()
	love.graphics.drawq(npc.image, npc.quads[npc.facing], npc.x, npc.y)
end

--Gets the tile the npc is on. (Tile Coords and not the name of the tile, duh!)
function npc.getTile()
	return npc.tileX, npc.tileY
end

--Gets the pixel positition the npc is on.
function npc.getPixel()
	return npc.x, npc.y
end

--Gets tile position by using pixel position.
function npc.pixelToTile()
	return npc.x / 32, npc.y / 32
end

--Gets the tile position based on the pixel position
function npc.tileToPixel()
	return npc.tileX * 32, npc.tileY * 32
end

--Gets the direction the npc is facing. Not that it is really needed.
function npc.isFacing()
	return npc.facing
end

function npc.spawn(map, x, y)
	npc.map = map
	npc.x, npc.y = npc.tileToPixel(x, y)
end

--Used for tween to switch moving state to false
local function movingState()
	if npc.moving == true then
		npc.moving = false
	end
end	

--Check if next tile is an obstacle
function npc.obstacle(x, y)
local ground = npc.map.tl["Ground"]
local furniture = npc.map.tl["Furniture"]
	if ground.tileData(x,y).properties.obstacle == 1  then 
		return true	
	else 
		return false
	end
end


--Check if the tile I'm facing has a useable object on it.
--Needs finished
function npc.actionCheck()
local obj = npc.map.ol["Useables"]
local obj2 = npc.map.tl["Useables"]
local offset = 16

if love.keyboard.isDown("e") and npc.moving == false then

if obj2.tileData(npc.tileX, npc.tileY - 1) == nil then
	return "nothing" end
	
if obj2.tileData(npc.tileX, npc.tileY - 1).properties.use == 1 then
	print("YAHOO!")
		end
	end
end

--Sets a bunch of variables then tweens the npc to the desired tile.
function npc.move()
local check
local newPos
local offset
local rnd = math.random(1,125)

if rnd == 5 and npc.moving == false then
	check = npc.tileY - 1
	if npc.obstacle(npc.tileX, check) == false then
		npc.moving = true
		newPos = npc.y - 32
		npc.tileY = npc.tileY - 1	
		offset =  { y = newPos }		
		else return end
end
	
if rnd == 22 and npc.moving == false then
	check = npc.tileX - 1
	if npc.obstacle(check, npc.tileY) == false then	
		npc.moving = true
		newPos = npc.x - 32
		npc.tileX = npc.tileX - 1
		offset =  { x = newPos }		
		else return end
end
		
if rnd == 12 and npc.moving == false then
	check = npc.tileY + 1
	if npc.obstacle(npc.tileX, check) == false then
		npc.moving = true
		newPos = npc.y + 32
		npc.tileY = npc.tileY + 1
		offset =  { y = newPos }	
		else return end
end
		
if rnd == 1 and npc.moving == false then
	check = npc.tileX + 1
	if npc.obstacle(check, npc.tileY) == false then	
		npc.moving = true
		newPos = npc.x + 32
		npc.tileX = npc.tileX + 1
		offset =  { x = newPos }	
		else return end
	end	
	
	if (offset) then
		tween(npc.speed, npc, offset, 'linear', movingState)
	end
	
end