tween = require("libraries/tween")

player = {}
player.image = love.graphics.newImage("images/maincharacter-1.png")
player.width = player.image:getWidth()
player.height = player.image:getHeight()
player.speed = 0.3
player.moving = false
player.facing = "down"
player.tileX = 3
player.tileY = 3
player.x = 0
player.y = 0
player.map = nil
player.quads = {
		down = love.graphics.newQuad( 0, 0, 32, 32, player.width, player.height )
}


--Draws the player --DON'T FORGET TO CHANGE QUADS WHEN PLAYER SPRITE IS DONE
function player.draw()
	love.graphics.drawq(player.image, player.quads["down"], player.x, player.y)
end

--Gets the tile the player is on. (Tile Coords and not the name of the tile, duh!)
function player.getTile()
	return player.tileX, player.tileY
end

--Gets the pixel positition the player is on.
function player.getPixel()
	return player.x, player.y
end

--Gets tile position by using pixel position.
function player.pixelToTile()
	return player.x / 32, player.y / 32
end

--Gets the tile position based on the pixel position
function player.tileToPixel()
	return player.tileX * 32, player.tileY * 32
end

--Spawns the player in the specified map at tile x and tile y
function player.spawn(map, x, y)
	player.map = map
	player.x, player.y = player.tileToPixel(x, y)
end

--Gets the direction the player is facing. Not that it is really needed.
function player.isFacing()
	return player.facing
end

--Gets the tile the player is facing. More useful than the function above.
function player.facingTile()
	if player.facing == "up" then
		return player.tileX, player.tileY - 1
	end
	
	if player.facing == "left" then
		return player.tileX - 1, player.tileY
	end
	
	if player.facing == "down" then
		return player.tileX, player.tileY + 1
	end
	
	if player.facing == "right" then
		return player.tileX + 1, player.tileY
	end
end

--Used for tween to switch moving state to false
local function movingState()
	if player.moving == true then
		player.moving = false
	end
end	

--Check if next tile is an obstacle
function player.obstacle(x, y)
local ground = player.map.tl["Ground"]
local walls = player.map.tl["Walls"]

if walls.tileData(x,y).properties == nil then
	return false
end

	if walls.tileData(x,y).properties.obstacle == 1  then 
		return true	
	else
		return false
	end
end

function player.Converse(npc)
print("Hi! I'm an NPC! Your NPC code is shit and you should probably fix that.")
end

--Check if the tile I'm facing has a useable object on it.
--Needs finished
function player.actionCheck()
local obj = player.map.ol["Usables"]
local obj2 = player.map.tl["Usables"]
local offset = 16
local facingX, facingY = player.facingTile()

if love.keyboard.isDown("e") and player.moving == false then

if obj2.tileData(facingX, facingY) == nil then
	return "nothing" end
	
if obj2.tileData(facingX, facingY).properties.use == 1 then
	print(obj2.tileData(facingX, facingY).properties.name)
		end
	end
end

--Sets a bunch of variables then tweens the player to the desired tile.
function player.move()
local check
local newPos
local offset

if love.keyboard.isDown("w") and player.moving == false then
	check = player.tileY - 1
	if player.obstacle(player.tileX, check) == false then
		player.moving = true
		player.facing = "up"
		newPos = player.y - 32
		player.tileY = player.tileY - 1	
		offset =  { y = newPos }		
		else return end
end
	
if love.keyboard.isDown("a") and player.moving == false then
	check = player.tileX - 1
	if player.obstacle(check, player.tileY) == false then	
		player.moving = true
		player.facing = "left"		
		newPos = player.x - 32
		player.tileX = player.tileX - 1
		offset =  { x = newPos }		
		else return end
end
		
if love.keyboard.isDown("s") and player.moving == false then
	check = player.tileY + 1
	if player.obstacle(player.tileX, check) == false then
		player.moving = true
		player.facing = "down"
		newPos = player.y + 32
		player.tileY = player.tileY + 1
		offset =  { y = newPos }	
		else return end
end
		
if love.keyboard.isDown("d") and player.moving == false then
	check = player.tileX + 1
	if player.obstacle(check, player.tileY) == false then	
		player.moving = true
		player.facing = "right"
		newPos = player.x + 32
		player.tileX = player.tileX + 1
		offset =  { x = newPos }	
		else return end
	end	
	
	if (offset) then
		tween(player.speed, player, offset, 'linear', movingState)
	end
	
end